#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll,ll> pll;

vector < vector < ll > > a, d;
vector < vector < bool > > used;
vector < vector < pll > > path;
vector < char > ans;

pll bfs(pll s)
{
    queue<pll> q;
    q.push(s);
    d[s.first][s.second]=0;
    used[s.first][s.second]=1;
    while(!q.empty())
    {
        pll v = q.front();
        q.pop();
        ll i = v.first, j = v.second;
        if(a[i-1][j]!=-1 && !used[i-1][j])
        {
            used[i-1][j] = 1;
            d[i-1][j] = d[i][j] + 1;
            q.push({i-1,j});
            path[i-1][j].first = i;
            path[i-1][j].second = j;
            if(i-1==0) return {i-1,j};
        }
        if(a[i+1][j]!=-1 && !used[i+1][j])
        {
            used[i+1][j] = 1;
            d[i+1][j] = d[i][j] + 1;
            q.push({i+1,j});
            path[i+1][j].first = i;
            path[i+1][j].second = j;
            if(i+1==a.size()-1) return {i+1,j};
        }
        if(a[i][j-1]!=-1 && !used[i][j-1])
        {
            used[i][j-1] = 1;
            d[i][j-1] = d[i][j] + 1;
            q.push({i,j-1});
            path[i][j-1].first = i;
            path[i][j-1].second = j;
            if(j-1==0) return {i,j-1};
        }
        if(a[i][j+1]!=-1 && !used[i][j+1])
        {
            used[i][j+1] = 1;
            d[i][j+1] = d[i][j] + 1;
            q.push({i,j+1});
            path[i][j+1].first = i;
            path[i][j+1].second = j;
            if(j+1==a[i].size()-1) return {i,j+1};
        }
    }
    return {-1,-1};
}

int main()
{
    freopen("labirint.in","r",stdin);
    freopen("labirint.out","w",stdout);
    ll m, n, x, y;
    string s;
    cin >> m >> n;
    cin.ignore();
    a.resize(m);
    for(ll i = 0; i<m; i++)
    {
        getline(cin,s);
        while(s.size()<n)
        {
            s = s+' ';
        }
        for(ll j = 0; j<n; j++)
        {
            if(s[j]==' ') a[i].push_back(0);
            else if(s[j]=='+') { a[i].push_back(1); x = i; y = j; }
            else a[i].push_back(-1);
        }
    }
    used.resize(m);
    d.resize(m);
    path.resize(m);
    for(ll i = 0; i<m; i++)
    {
        used[i].resize(n,0);
        d[i].resize(n);
        path[i].resize(n);
    }
    if(x==0 || x==m-1 || y==0 || y==n-1)
    {
        cout << 0 << '\n';
    }
    else
    {
        pll t = bfs({x,y});
        if(t.first==-1) cout << -1 << '\n';
        else
        {
            cout << d[t.first][t.second] << '\n';
            ll i = t.first, j = t.second;
            while(i!=x || j!=y)
            {
                ll l = i, r = j;
                i = path[l][r].first;
                j = path[l][r].second;
                if(i<l) ans.push_back('s');
                else if(i>l) ans.push_back('n');
                else if(j<r) ans.push_back('e');
                else ans.push_back('w');
            }
            for(ll i = ans.size()-1; i>=0; i--)
            {
                cout << ans[i];
            }
            cout << '\n';
        }
    }
}
