#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> big;

const int base = 1000000;
bool noll = false;

struct seq {
    int a, d;
};

struct big_seq {
    big a, d;
};

bool operator==(big &a, int b) {
    return (a.size() == 1 && a.back() == b);
}

bool operator<=(big &a, int b) {
    return (a.size() == 1 && a.back() <= b);
}

bool operator<=(int a, big &b) {
    return (b.size() == 1 && a <= b.size());
}
big operator- (big a, int b){
    a[0] -= b;
    int i = 0;
    while(i < a.size()-1 && a[i] < 0) {
        a[i] += base;
        a[i+1]--;
    }
    while(a.size() > 1 && a.back() == 0) a.pop_back();
    return a;
}

int operator%(big a, int b) {
    int hV = 0, k = 1;
    for(int i = 0;i < a.size();++i) {
        hV += a[i]%b*k%b;
        hV %= b;
        k = k*(base % b) % b;
    }
    return hV;
}

int operator%(int a, big b) {
    if(b.size() > 1)
        return a;
    else
        return a%b.back();
}

big operator*(big a, int b) {
    ll hV = 0;
    for(int i = 0;i < a.size()||hV;++i) {
        if(a.size() <= i)
            a.push_back(0);
        hV += ll(a[i])*b;
        a[i] = hV%base;
        hV /= base;
    }
    while(a.size() > 0 && a.back() == 0) a.pop_back();
    return a;
}
big operator+(big a, big b) {
    int hV = 0;
    for(int i = 0;i < a.size() || i < b.size() ||hV;++i) {
        if(a.size() <= i)
            a.push_back(0);
        a[i] += hV + (i < b.size() ? b[i] : 0);
        hV = a[i]/base;
        a[i] %= base;
    }
    while(a.size() > 0 && a.back() == 0) a.pop_back();
    return a;
}

big operator+(int a, big b) {
    int hV = a;
    for(int j = 0;hV;++j) {
        if(j >= b.size())
            b.push_back(0);
        b[j] += hV;
        hV = b[j]/base;
        b[j] %= base;
    }
    while(b.size() > 0 && b.back() == 0) b.pop_back();
    return b;
}
big operator/(big a, int b) {
    int hV = 0;
    for(int i = a.size()-1;i >= 0;--i) {
        hV = (hV*base+a[i])%b;
        a[i] = a[i]/b;
    }
    while(a.size() > 0 && a.back() == 0) a.pop_back();
    return a;
}
void union_seq(big_seq &a, seq b) {
    if(a.d == 0 && b.d == 0) {
        if(a.a == b.a)
            return;
        noll = true;
        return;
    }
    if(a.d == 0 && b.d > 0) {
        if(b.a <= a.a && (a.a-b.a)%b.d == 0)
            return;
        noll = true;
        return;
    }
    if(b.d == 0 && (a.d.size() > 1 || a.d.back() > 0)) {
        if(a.a <= b.a && (b.a-a.a.back())%a.d == 0) {
            a.a.resize(1);
            a.a.back() = b.a;
            a.d.resize(1);
            a.d.back() = 0;
            return;
        }
        noll = true;
        return;
    }
    if(a.a.size() == 1) {
        if((a.a.back()-b.a) % __gcd(a.d%b.d, b.d) == 0) {
            int k = 0;
            while((a.a.back()-b.a + a.d*k) % b.d != 0)
                k++;
            a.a = a.a.back() + a.d*k;
            a.d = a.d/__gcd(a.d%b.d, b.d)*b.d;
            return;
        }
    }
    else{
        if((a.a-b.a) % __gcd(a.d%b.d, b.d) == 0) {
            int k = 0;
            while((a.a-b.a + a.d*k) % b.d != 0)
                k++;
            a.a = a.a + a.d*k;
            a.d = a.d/__gcd(a.d%b.d, b.d)*b.d;
            return;
        }
    }
    noll = true;
}
int main()
{
    freopen("common.in", "r", stdin);
    freopen("common.out", "w", stdout);
    int n;
    seq b;
    int x, y;
    cin >> n;
    cin >> x >> y;
    big_seq a;
    a.a.resize(1);
    a.a.back() = x;
    a.d.resize(1);
    a.d.back() = y;
    while(--n) {
        cin >> b.a >> b.d;
        union_seq(a, b);
        if(noll) {
            cout << 0 << endl;
            return 0;
        }
    }

    printf("%d", a.a.back());
    for(int i = a.a.size()-2;i >=0;i--) {
        printf("%06d", a.a[i]);
    }
    printf("\n");
    return 0;
}
