/* GCC */
#include <bits/stdc++.h>
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)

using namespace std;
typedef pair<int, int> pii;
typedef long long lint;
const lint inf = 1000*1000*1000 + 7;

vector< vector<int> > maze;
vector<char> path;
queue<pii> q;
string s;

int main() {

    files(labirint);
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

    int m, n, ih, jh;

    cin >> m >> n;
    maze.resize(m, vector<int>(n));
    getline(cin, s);

    for (int i = 0; i < m; i++) {
        getline(cin, s);
        for (int j = 0; j < n; j++) {
            if (s[j] == '+') ih = i, jh = j;
            maze[i][j] = (s[j] == ' ' ? 0 : inf);
        }
    }

    maze[ih][jh] = 1;
    q.push(pii(ih, jh));
    int i, j;

    while (!q.empty()) {
        i = q.front().first, j = q.front().second;
        if (i == 0 || j == 0 || i == m-1 || j == n-1) break;
        q.pop();
        int d = maze[i][j] + 1;
        if (i > 0 && maze[i-1][j] == 0)
            maze[i-1][j] = d, q.push(pii(i-1, j));
        if (j > 0 && maze[i][j-1] == 0)
            maze[i][j-1] = d, q.push(pii(i, j-1));
        if (i < m-1 && maze[i+1][j] == 0)
            maze[i+1][j] = d, q.push(pii(i+1, j));
        if (j < n-1 && maze[i][j+1] == 0)
            maze[i][j+1] = d, q.push(pii(i, j+1));
    }

    if (q.empty()) {
        cout << "-1\n";
        return 0;
    }

    cout << maze[i][j]-1 << '\n';

    if (maze[i][j] == 1) return 0;

    while (i != ih || j != jh) {
        if (i > 0 && maze[i-1][j] == maze[i][j]-1)
            i--, path.push_back('s');
        /*else*/ if (j > 0 && maze[i][j-1] == maze[i][j]-1)
            j--, path.push_back('e');
        if (i < m-1 && maze[i+1][j] == maze[i][j]-1)
            i++, path.push_back('n');
        if (j < n-1 && maze[i][j+1] == maze[i][j]-1)
            j++, path.push_back('w');
    }

    for (int i = (int)path.size()-1; i >= 0; --i)
        cout << path[i];
    cout << '\n';

    return 0;
}
