/* GCC */
#include <bits/stdc++.h>
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)

using namespace std;
typedef long long lint;

struct prog {
    lint a0, d;
    prog(lint a0=0, lint d=-1): a0(a0), d(d) {}
};

prog intersect(prog& a, prog& b) {
    if (a.d == 0 && b.d == 0) {
        if (a.a0 == b.a0) return a;
        else return prog();
    }
    if (a.d > 0 && b.d == 0) swap(a, b);
    if (a.d == 0 && b.d > 0) {
        if (/*a.a0 >= b.a0 && */(a.a0 - b.a0) % b.d == 0) return a;
        else return prog();
    }
    lint g = __gcd(a.d, b.d);
    if ((a.a0 - b.a0) % g == 0) {
        lint c = a.a0 - b.a0;
        while (c % b.d)
            c += a.d;
        return prog(c + b.a0, a.d/g*b.d);
    } else return prog();
}

int main() {

    files(common);
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

    prog cur, nxt;
    int n;
    cin >> n; n--;
    cin >> cur.a0 >> cur.d;
    while (n--) {
        cin >> nxt.a0 >> nxt.d;
        cur = intersect(cur, nxt);
        if (cur.d == -1) {
            cout << 0 << '\n';
            return 0;
        }
    }

    cout << cur.a0 << '\n';

    return 0;
}
